# encoding: utf-8

module FetchData
  #this file handle with data, which are needed for system
  def fetch_ats
    ats = []
    ats[0] = Ats.new(:id => 0, :name_status => 'Test zatím nebyl napsán')
    ats[1] = Ats.new(:id => 1, :name_status => 'Opravit test')
    ats[2] = Ats.new(:id => 2, :name_status => 'Opraveno - Qualified')
    ats[3] = Ats.new(:id => 3, :name_status => 'Opraveno - Failed')
    ats[4] = Ats.new(:id => 4, :name_status => 'Telefonické interview I')
    ats[5] = Ats.new(:id => 5, :name_status => 'Telefonické interview II')
    ats[6] = Ats.new(:id => 6, :name_status => 'Telefonické interview III')
    ats[7] = Ats.new(:id => 7, :name_status => 'Nabídka odeslána')
    ats[8] = Ats.new(:id => 8, :name_status => 'Vyjednávání nabídky')
    ats[9] = Ats.new(:id => 9, :name_status => 'Nabídka akceptována')
    ats[10] = Ats.new(:id => 10, :name_status => 'Nabídka odmítnuta')
    ats[11] = Ats.new(:id => 11, :name_status => 'Pozastaven')
    ats[12] = Ats.new(:id => 12, :name_status => 'Telefonické interview - zrušeno')
    ats[13] = Ats.new(:id => 13, :name_status => 'Telefonické interview - failed')
    ats[14] = Ats.new(:id => 14, :name_status => 'Technické interview - zrušeno')
    ats[15] = Ats.new(:id => 15, :name_status => 'Technické interview - failed')
    ats[16] = Ats.new(:id => 16, :name_status => 'HR interview - zrušeno')
    ats[17] = Ats.new(:id => 17, :name_status => 'Vyřešený')

    ats.each do |ats|
      ats.save
    end
  end

  def fetch_status
    status = []
    status[0] = Status.new(:id => -1, :name_status => 'Nový', :tag => 'new')
    status[1] = Status.new(:id => 0, :name_status => 'Online test - pozvaný', :tag => 'newTest')
    status[2] = Status.new(:id => 1, :name_status => 'Online test - neopravený', :tag => 'notCorrected')
    status[3] = Status.new(:id => 2, :name_status => 'Online test - qualified', :tag => 'qualified')
    status[4] = Status.new(:id => 3, :name_status => 'Online test - failed', :tag => 'failed')
    status[5] = Status.new(:id => 4, :name_status => 'Online test - vypršel', :tag => 'testExpired')
    status[6] = Status.new(:id => 5, :name_status => 'Pozvat na prescreening', :tag => 'phonePrescreening')
    status[7] = Status.new(:id => 6, :name_status => 'Proběhl prescreening', :tag => 'prescreeningPast')
    status[8] = Status.new(:id => 7, :name_status => 'Pozvat na pohovor', :tag => 'interview')
    status[9] = Status.new(:id => 8, :name_status => 'Proběhl pohovor', :tag => 'interviewPast')
    status[10] = Status.new(:id => 9, :name_status => 'Zjistit reference', :tag => 'findReference')
    status[11] = Status.new(:id => 10, :name_status => 'Pozastavený', :tag => 'stopped')
    status[12] = Status.new(:id => 11, :name_status => 'Najatý', :tag => 'hired')
    status[13] = Status.new(:id => 12, :name_status => 'Odmítnul nabídku', :tag => 'offerDeclined')
    status[14] = Status.new(:id => 13, :name_status => 'Nechceme jej, nutno kontaktovat', :tag => 'DontWantHim')
    status[15] = Status.new(:id => 14, :name_status => 'Zamítnutý a ví o tom', :tag => 'rejected')
    status[16] = Status.new(:id => 16, :name_status => 'Vyřešený', :tag => 'solved')
    status[17] = Status.new(:id => 17, :name_status => 'Vyřešený', :tag => 'solved')
    status.each do |status|
      status.save
    end
  end

  def fetch_user_status
    userStatus = []
    userStatus[0] = State.new(:id => -1, :name_of_status => 'Test nenapsán')
    userStatus[1] = State.new(:id => 1, :name_of_status => 'Test dokončen')
    userStatus[2] = State.new(:id => 7, :name_of_status => 'Test dokončen')
    userStatus.each do |us|
      us.save
    end
  end

  def fetch_email_template
    email_template = []
    email_template[0] = Email.new(:id => 0, :text => 'Dobrý den, {NAME},{EOL}níže naleznete odkaz na online test.{EOL}Cílem je dovědět se více o Vašich analytických a algoritmických dovednostech.' +
    '{EOL}Test slouží jak k základnímu poznání uchazečů, tak i jako podklad pro případný ústní pohovor. Zde se podrobněji podíváme na to, jak Vám bude daná pozice po všech směrech vyhovovat.' +
    '{EOL}Ujistěte se prosím, zda máte stabilní internetové připojení, tužku a papír.' +
    '{EOL}V případě, že test nestihnete vyplnit ve stanoveném čase, neváhejte mě kontaktovat.{EOL}{EOL}Test vyprší {DATE}' +
    '{EOL}Na test máte 60 minut.{EOL}{EOL}Naleznete jej na odkaze:' +
    '{EOL}{LINK}{EOL}{EOL}{EOL}Hodně štěstí ve vyplňování přeje{EOL}',
    :name_of_template => 'Nová pozvánka', :subject => "Pozvánka na online test")
    email_template[1] = Email.new(:id => 0, :text => 'Dobrý den,{EOL}{EOL}asi před týdnem jsem Vám zasílala online test, který se vztahoval k pozici, o kterou se ucházíte v naší společnosti SDE. Bohužel již vypršela jeho platnost.' +
    '{EOL}Ráda bych se proto zeptala, zda Vám pozvánka byla v pořádku doručena, popřípadě zda Váš zájem o pozici stále trvá.{EOL}' +
    '{EOL}Link s testem posílám pro jistotu znovu:{EOL}{LINK}{EOL}{EOL}Děkuji za vaši odpověď,{EOL}{EOL}' +
    's pozdravem a přáním hezkého dne{EOL}{EOL}', :name_of_template => 'Upomínka', :subject => "Upomínka")
    email_template.each do |email|
      email.save
    end
  end

  def fetch_token
    tok = Token.new(:token => 'Here should be token')
    tok.save
  end

  def save_tests(tests)
    tests['data'].each do |t|
      test = Test.new(:name_of_test => t['name'], :id => t['id'])

      #if any errors occurred we save it to log file
      if !test.save
        test.errors.each do |error|
          puts error
        end
      end
    end
  end

  #function for updating data about candidates
  def update_data(candidate, all_candidates, load_comments)
    found = false
    all_candidates.each do |c|
      if candidate.email == c.email && candidate.test.id == c.test.id
        found = true
        if (candidate.test_link != c.test_link ||
            candidate.report_link != c.report_link ||
            candidate.ats.id != c.ats.id ||
            candidate.state.id != c.state.id ||
            candidate.status.id != c.status.id ||
            candidate.date_when_test_written != c.date_when_test_written ||
            candidate.hacker_rank_id != c.hacker_rank_id)
            c.update(:test_link => candidate.test_link)
            c.update(:report_link => candidate.report_link)
            c.update(:ats => candidate.ats)
            c.update(:date_when_test_written => candidate.date_when_test_written)
            c.update(:state => candidate.state)
            c.update(:hacker_rank_id => candidate.hacker_rank_id)

            if(c.status.id < 5)
              c.update(:status => candidate.status)
            end
        end
        if candidate.test_result != c.test_result && load_comments
          c.update(:test_result => candidate.test_result,)
        end
        break
      end
    end
    #if found is false, then candidate is new and we have to save him
    if !found
      candidate.save
    end
  end

  def save_data(candidate)
    if !candidate.save
      candidate.errors.each do |error|
        puts error
      end
    end
  end

  def save_invitation(date, candidate, email_template)
    invite = Invitation.new(:date_send => date,
                            :candidate => candidate[0],
                            :email => email_template,
                            :test => candidate[0].test)
    if !invite.save
      invite.errors.each do |error|
        puts error
      end
    end
  end

  def make_invitation
    all_candidates = Candidate.all
    all_invites = Invitation.all
    email_template = Email.get(1)

    all_candidates.each do |c|
      found = false
      all_invites.each do |i|
        if i.candidate && i.candidate.email
          if c.email == i.candidate.email &&
             c.test.id == i.candidate.test.id
             found = true
            break
          end
        end
      end

      if !found
        invite = Invitation.new(:date_send => c.date_of_invite ? c.date_of_invite : c.date_when_test_written,
                                :candidate => c,
                                :email => email_template,
                                :test => c.test)
        if !invite.save
          invite.errors.each do |error|
            puts error
          end
        end
      end
    end
  end
end

# vim:ff=unix ts=2 ss=2
