(function () {
  'use strict';
  var mainForm;
  /*
  *Constructor
  */
  function Form(){
    var obj = this;
    obj.hideElements();
    obj.filteringVisible = false;
    obj.invitationVisible = false;
    obj.refresh = false; //was site any time refreshed?
    obj.htmlSolved = '';
    obj.choosenElement = {};
    obj.solvedShow = false;
    obj.choosenCandidate = {};
    obj.emailTemplates = {};
    obj.atsStatuses = {};
    obj.allInvites =  {};
    obj.choosenTemplate = {};
    obj.lengthOfExpiration = 3;
    obj.nameChange = false;
    obj.statusChange =  false;
    obj.choosenElementNote1 = {};
    obj.choosenElementNote2 = {};
    obj.dateInterviewChange =  false;
    obj.note1Change =  false;
    obj.note2Change =  false;
    obj.datePrescreeningChange =  false;
    obj.checkStatuses = [];
    obj.checkTests = [];
    obj.statuses = {};
    obj.allUsers = {};
    obj.htmlElement = {};
    obj.loadLoggedUser();
    obj.howLongLoaded();  //function for counting how long site is loaded
    obj.loadAtsStatuses();
    obj.formArray = {filterByStatus: 'candidates',
              filterByTest: 'allTest',
              email: '',
              name: '',
              inviteTest: 0,
              sendTest: true,
              emailTemplate: '1'};
  }

  //function for setting selected variables
  Form.prototype.refreshData = function(){
    $('.testSelect').html('');
    $('#filterByTest').html('');

    //  if we reload page, we have to add these selects
    $('#invitationTestId').append('<option value = "0" selected>Vyberte test</option>');
  };

  /*
  *Function for loading tests from hackerrank.com over AJAX calling
  *@param callback - function for writing data after loading data
  */
  Form.prototype.inicializeFunction = function(){
    $('#tableStart').prepend('<div class = "alert alert-warning timeout loadingData" role = "alert" id = "loading">' +
    '<span class = "alertText">Nahrávám data <span id="loading-dots">.</span></span></div>');
    var obj = this;
    //obj.setButtonDisabled();
    obj.personArray = []; //delete what is saved
    obj.testArray = [];  //delete what is saved
    obj.timeoutForData();
    obj.loadAllUsers();
    if(obj.refresh){
      obj.refreshData();
    }
    obj.loadTests(function(){  //load of test, users...
      obj.writeCandidates();
      if(!obj.refresh){
        $('#sortingTable').DataTable( {
          paging: false
        } );
      }
      obj.filter();
      $('#loading').hide('fast');
    });
    obj.loadEmailTemplate();
  };
  /*
  *Function checking if site was reloaded for some time, after that alert will be show
  */
  Form.prototype.timeoutForData = function(){
    setTimeout(function(){
      $('#timeout').append('<div class = "alert-warning timeout loading" role = "alert" id = "loading">' +
      '<span class = "timeoutText">Stránka již nebyla delší dobu obnovena, ' +
      'data mohou být neaktuální!<br>' +
      '<input type = "button" id = "continue" value = "Pokračovat"></span></div>');
    }, 1800000); // milisecond to show alert, that data can be old
  };

  /*
  *Function for loading tests from hackerrank.com over AJAX calling
  *@param callback - function for writing data after loading data
  */
  Form.prototype.loadTests = function(callback){
    var obj = this;
    $.ajax({
      url: '/load_tests',
      dataType: 'json',
      success: function(data){
        obj.saveTests(data, callback);
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani testu ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for loading all users
  */
  Form.prototype.loadAllUsers = function(){
    var obj = this;
    $.ajax({
      url: '/load_all_users',
      dataType: 'json',
      success: function(data){
        obj.allUsers = data;
        if(data !== 'false'){
          var select = '<td><select id="allUsers">';
          $.each(data, function(i, user){
            select += '<option value = "' + user.id + '">' + user.name + ' - ' + user.auth + '</option>';
          });
          select += '</select><td><td></td>';
          $('#allUsers').append(select);
        }
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani uživatelů ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for loading actually logged user
  */
  Form.prototype.loadLoggedUser = function(){
    var obj = this;
    $.ajax({
      url: '/logged_user',
      dataType: 'json',
      success: function(data){
        obj.lengthOfExpiration = data.expiration;
        $('#expiration').val(obj.lengthOfExpiration);
        if(data && data.auth === 'admin'){
          var addNewUser ='<li id="addUser" data-toggle="modal" data-target="#addUserModal">' +
                          '<a href="#">Přidat nového uživatele</a></li>';
          $('#settings').append(addNewUser);
        }
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani uživatele ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for loading all email templates
  */
  Form.prototype.loadEmailTemplate = function(){
    var obj = this;
    $.ajax({
      url: '/load_email_template',
      dataType: 'json',
      success: function(data){
        obj.emailTemplates = data;
        $.each(obj.emailTemplates, function(i, template){
          $('.emailTemplate').append('<option value = "' + template.id + '">' + template.name_of_template + '</option>');
        });
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani šablon pro email ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for checking if checkboxes are checked
  */
  Form.prototype.statusHandover = function(data, checked){
    var obj = this;
    if(checked){
      obj.checkStatuses.push({id: data});
      obj.filter();
      if(data === 'solved'){
        $('#testUsers').append(obj.htmlSolved);
      }
    }else{
      $.each(obj.checkStatuses, function(i, status){
        if(status && status.id === data){
          obj.checkStatuses.splice(i, 1);
          obj.filter();
        }
        if(data === 'solved'){
          $('.solved').remove();
        }
      });
    }
  };

  /*
  *Function, which save which tests are checked in test filtering
  */
  Form.prototype.testHandover = function(data, checked){
    var obj = this;
    if(checked){
      obj.checkTests.push({id: data});
      obj.filter();
    }else{
      $.each(obj.checkTests, function(i, test){
        if( test && test.id === data){
          obj.checkTests.splice(i, 1);
          obj.filter();
        }
      });
    }
  };

  /*
  *Function for filtering datas
  */
  Form.prototype.filter = function(){
    var obj = this;
    $('.candidates').hide('slow');
    if(obj.checkStatuses.length === 0){
      if(obj.checkTests.length === 0){
        $('.candidates').show('slow');
      }else {
        $.each(obj.checkTests, function(i, test){
          $('.' + test.id).show('slow');
        });
      }
    }else{
      $.each(obj.checkStatuses, function(i, status){
        if(obj.checkTests.length === 0){
          $('.' + status.id).show('slow');
        }else {
          $.each(obj.checkTests, function(i, test){
            $('.' + test.id + '.' + status.id).show('slow');
          });
        }
      });
    }
  };

  /*
  *Function for loading all statuses
  */
  Form.prototype.loadStatus = function(){
    var obj = this;
    var checked = 'checked="true"';
    $.ajax({
      url: '/load_status',
      dataType: 'json',
      success: function(data){
        obj.statuses = data;
        $.each(obj.statuses, function(i, status){
          if(!(i < 12)){
            checked = '';
          }else{
            if(i === 4){
              checked = '';
            }else{
              checked = 'checked="true"';
              obj.checkStatuses.push({id: status.tag});
            }
          }
          $('#statusDropdown').append('<li><a href="#"><label><input type="checkbox" value="' + status.tag +
          '" onchange="mainForm.statusHandover(this.value, this.checked);"' + checked + '>' + status.name_status + '</input></label></a></li>');
        });
        obj.loadInvites();
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani statusů', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for loading all user invites
  */
  Form.prototype.loadInvites = function(){
    var obj = this;
    $.ajax({
      url: '/load_invites',
      dataType: 'json',
      success: function(data){
        obj.allInvites = data;
        obj.inicializeFunction();
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani pozvánek ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for loading ats statuses
  */
  Form.prototype.loadAtsStatuses = function(){
    var obj = this;
    $.ajax({
      url: '/load_ats',
      dataType: 'json',
      success: function(data){
        obj.atsStatuses = data;
        obj.loadStatus();
      },
      error: function(jqXHR, textStatus, errorThrown){
        obj.showError('Nekde se stala chyba v nahravani šablon pro email ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function for parsing data from JSON
  *@param contents - json data, callback - function for writing data after loading data
  */
  Form.prototype.saveTests = function(contents, callback){
    var obj = this;
    obj.testArray = contents;
    $.each(obj.testArray, function(i, test){
      //obj.checkTests.push({id: test.id, value: false});
      $('#filterByTest').append('<li><a href="#"><label><input type="checkbox" value="' + test.id +
       '" onchange="mainForm.testHandover(this.value, this.checked);"> ' + test.name_of_test + '</input></label></a></li>');
      $('.testSelect').append('<option value = "' + test.id + '">' + test.name_of_test + '</option>');
    });
    obj.loadCandidates(callback);
  };

  /*
  *Function for loading person from hackerrank.com over AJAX calling
  *@callback - function for writing data after loading data
  */
  Form.prototype.loadCandidates = function(callback){
    var obj = this;
    $.ajax({
      url: '/load_candidates',
      dataType: 'json',
      success: function(data){
        obj.savePerson(data);
        callback();
      },
      error: function(jqXHR, textStatus, errorThrown){
        $('#loading').remove();
        obj.showError('Nekde se stala chyba v nahravani osob: ', textStatus, errorThrown);
      }
    });
  };

  /*
  *Function which finds name of test from id
  */
  Form.prototype.findTestName = function(id){
    var obj = this;
    var name = '';
    $.each(obj.testArray, function(i, test){
      if(id === test.id){
        name = test.name_of_test;
      }
    });
    return name;
  };

  /*
  *Function which finds id of test from name
  */
  Form.prototype.findTestID = function(name){
    var obj = this;
    var id = 0;
    $.each(obj.testArray, function(i, test){
      if(name === test.name_of_test){
        id = test.id;
      }
    });
    return id;
  };

  /*
  *Function which finds name of ats status from id
  */
  Form.prototype.findAts = function(id){
    var obj = this;
    var atsStatus;
    $.each(obj.atsStatuses, function(i, ats){
      if(id === ats.id){
        atsStatus = ats;
      }
    });
    return atsStatus;
  };

  /*
  *Function which converts nice date to system date
  */
  Form.prototype.convertToSysDate = function(date){
    if(date === null){
      return '';
    }else{
      date = new Date(date);
      var days = ('0' + date.getDate()).slice(-2);
      var months = ('0' + (date.getMonth() + 1)).slice(-2);
      date = date.getFullYear() + '-' + months + '-' + days;
      return date;
    }
  };

  /*
  *Function which finds system date to nice date
  */
  Form.prototype.convertToNormDate = function(date){
    if(date !== ''){
      date = new Date(date);
      date = date.getDate() + '.' + (date.getMonth()+1) + '.' + date.getFullYear();
      return date;
    }else{
      return '';
    }
  };

  /*
  *Function which finds all invites for user
  */
  Form.prototype.findInvites = function(user){
    var invites = [];
    var obj = this;
    $.each(obj.allInvites, function(i, invite){
      if(user.id === invite.candidate_id &&
         user.test_id === invite.test_id){
        invites.push(invite);
      }
    });
  return invites;
  };

  /*
  *Function which finds name of status from id
  */
  Form.prototype.findStatus = function(statusID){
    var stat;
    var obj = this;
    $.each(obj.statuses, function(i, status){
      if(status.id === statusID){
        stat = status;
      }
    });
    return stat;
  };

  /*
  *Function for parsing info about person into array
  *@param contents - json data , testId - id of test, name - name of test
  */
  Form.prototype.savePerson = function(candidates){
    var obj = this;
    var dateOfInterview;
    var dateOfInvit;
    var dateOfPrescreening;
    var nameTest;
    var ats;
    var invites;
    var status;
    var dayLeftFromInvitation;
    $.each(candidates, function(i, user){
      nameTest = obj.findTestName(user.test_id);
      ats = obj.findAts(user.ats_id);
      invites = obj.findInvites(user);
      dateOfInterview = obj.convertToSysDate(user.date_of_interview);
      dateOfPrescreening = obj.convertToSysDate(user.date_of_prescreening);
      dateOfInvit = user.date_of_invite;
      dayLeftFromInvitation = obj.dateParse(new Date(dateOfInvit));
      if(dayLeftFromInvitation > 7 && user.state_id === -1 && user.status_id < 5){
        status = obj.findStatus(4);
      }else{
        status = obj.findStatus(user.status_id);
      }
      obj.personArray.push({
          databaseID: user.id,
          testLink: user.test_link, //link for test
          userId: user.hacker_rank_id, //id of user
          nameOfTest: nameTest, //name of test
          testID: user.test_id, //test id
          endTimeTestW: user.date_when_test_written, // date when test was written
          dateOfInvite: dateOfInvit, //when was user invited
          howManyTimesW: invites.length, // how many different test user writes
          ats: ats,
          status: status,
          userStatus: user.state_id, // user status
          email: user.email, //email of user
          nameOfUser: user.name,//name of user
          report: user.report_link, // link of user report
          dayLeftFromInvitation: obj.dateParse(new Date(dateOfInvit)), //how many days from invite left
          dayLeftFromTestW: user.date_when_test_written ? obj.dateParse(new Date(user.date_when_test_written)) : 0,// how many days from test written left
          comment: user.test_result, //comment with results of test
          dateOfInterview: dateOfInterview,
          dateOfPrescreening: dateOfPrescreening,
          note1: user.note1 ? user.note1 : '',
          note2: user.note2 ? user.note2 : '',
          invites: invites,
          passwordToTest: user.password_to_test
        });
    });
  };

  /*
  *Function which shows error alert
  */
  Form.prototype.showError = function(text, textStatus, errorThrown){
    if(textStatus === undefined && errorThrown === undefined){
      textStatus = '';
      errorThrown = '';
    }
    $('#tableStart').prepend('<div class = "alert alert-danger" role = "alert">' +
    text + textStatus + ' ' + errorThrown + '</div>');
    this.setTimer('alert', 7000);
  };

  /*
  *Function which shows success alert
  */
  Form.prototype.showSuccess = function(text){
    $('#tableStart').prepend('<div class = "alert alert-success" role = "alert">' +
    text + '</div>');
    this.setTimer('alert-success', 7000);
  };

  /*
  *Function which shows warning alert
  */
  Form.prototype.showWarning = function(text){
    $('#tableStart').prepend('<div class = "alert alert-warning" role = "alert" id = "loading">' +
    text + '</div>');
    this.setTimer('alert', 7000);
  };

  /*
  *Function which return date of last invite for user
  */
  Form.prototype.lastInvite = function(candidate){
    var len = candidate.invites.length - 1;
    if(candidate.invites[len]){
      var last = candidate.invites[len].date_send;
      return this.dateParse(new Date(last)) + ' dny, ' + this.convertToNormDate(last);
    }
  };

  /*
  *Function which returns html code for test column
  */
  Form.prototype.testInformations = function(candidate){
    var color = '';
    var days = '';
    var date = this.convertToNormDate(candidate.dateOfInvite);
    if(candidate && candidate.status && candidate.status.id === -1){
      days = '<td id="testinformations">';
    } else {
        if (candidate.dayLeftFromInvitation > 7 && candidate.userStatus === -1) {
            color = 'class="expired"';
        }
        var markDelay = this.checkMarkDelay(candidate);
        if (markDelay.length !== 0) {
            color = 'class= ' + markDelay;
        }
        days = '<td id="testinformations" ' + color + '>';

      if(candidate.userStatus === -1){ //user did not writte the test
        days += 'Posláno před ' + candidate.dayLeftFromInvitation + ' dny, ' + date + '<br>';
        if(candidate.dayLeftFromInvitation > 7){
          days += 'Pozvánka vypršela,';
        }else{
          days += 'Pozvánka vyprší za ' + (7-candidate.dayLeftFromInvitation) + ' dní,';
        }
        days += '<div id="remindCount">' + (candidate.howManyTimesW - 1) + ' upomenutí. Naposledy před: '+this.lastInvite(candidate)+'</div>';
      }else if(candidate.ats.id !== 0){ //if user does not have ATS status (he didn't write test)
        if(candidate.endTimeTestW){
          date = new Date(candidate.endTimeTestW);
          days += 'Test byl napsán před ' + candidate.dayLeftFromTestW+ ' dny.<br>' +
          date.getDate() +'. ' +(date.getMonth() + 1) + '. ' +
          date.getFullYear() + '<br>';
        }else if(candidate.ats.id === 1){
          days += 'Zatím neopraveno';
          days += '<br>Posláno před ' + candidate.dayLeftFromInvitation + ' dny, ' + date;
        }
        if(candidate.comment !== 'Nezadáno'){
          days += candidate.comment;
        }
      }
      days += '</td>';
    }
    return days;
  };

  /*
  *Function which returns html code with date for date of interview
  */
  Form.prototype.dateInterview = function(candidate){
    var obj = this;
    var date = '<td id="interview" ';
    if(candidate.dateOfInterview !== ''){
      var numberOfDays = this.dateParse(new Date(candidate.dateOfInterview));
      if(numberOfDays < 0){
        date += '>Za ' + -numberOfDays + 'dní.\n' ;
      }else{
        if(numberOfDays > obj.lengthOfExpiration && candidate.status.id < 10){
          date += 'class="expired"';
        }
        date += '>Před ' + numberOfDays + ' dny.\n' ;
      }
      date += this.convertToNormDate(candidate.dateOfInterview);
    }else{
      date += '>';
    }
    date += '</td>';

    return date;
  };

  /*
  *Function which returns html code with date for prescreening
  */
  Form.prototype.datePrescreening = function(candidate){
    var obj = this;
    var date = '<td id="prescreening" ';
    if(candidate.dateOfPrescreening !== ''){
      var numberOfDays = this.dateParse(new Date(candidate.dateOfPrescreening));
      if(numberOfDays < 0){
        date += '>Za ' + -numberOfDays + 'dní.\n' ;
      }else{
        if(numberOfDays > obj.lengthOfExpiration && !candidate.dateOfInterview){
          date += 'class="expired"';
        }
        date += '>Před ' + numberOfDays + ' dny.\n' ;
      }
      date += this.convertToNormDate(candidate.dateOfPrescreening);
    }else{
      date += '>';
    }
    date += '</td>';
    return date;
  };

  /*
  *Function which add rows with candidates to html
  */
  Form.prototype.writeCandidates = function(){
    $('#testUsers').html('');
    var obj = this;
    var body = '';
    obj.personArray.forEach(function(candidate){
      body = obj.convertToHtml(candidate);
      if(candidate.ats.id === 17 || candidate.status.id === 17){
        obj.htmlSolved += body;
      }else{
        $('#testUsers').append(body);
      }
    });
  };

  //if test hasn't been checked (marked) by manager
  //then the test will be highlighted by red color
  Form.prototype.checkMarkDelay = function (candidate) {
      if (candidate.dayLeftFromInvitation > 3 &&
          (candidate.status.id === 1)) {//1 = not corrected yet
          return 'notCorrectedForLong';
      }
      return '';
  };

  /*
  *Function which converts candidate to html row
  */
  Form.prototype.convertToHtml = function(candidate){
    var testInformations = this.testInformations(candidate);
    var dateInterview = this.dateInterview(candidate);
    var datePrescreening = this.datePrescreening(candidate);
    var body = '<tr id="' + candidate.databaseID + '" class="candidates ' + candidate.status.tag + ' ' + candidate.testID +'">' +
                 '<td id="nameAndEmail">' + candidate.nameOfUser +
                   '<div id="emailOfUser">' + candidate.email + '</div>' +
                 '</td>' +
                 '<td id="nameOfTest">' + candidate.nameOfTest + '</td>' +
                 '<td id="status">' + candidate.status.name_status + '</td>' +
                 testInformations + datePrescreening + dateInterview +
                 '<td id="note1">' + candidate.note1 + '</td>' +
                 '<td id="note2">' + candidate.note2 + '</td>' +
               '</tr>';
    return body;
  };

  /*
  *Function which adjust height of text area
  */
  Form.prototype.textAreaAdjust = function(text){
    var length = text.length;
    return (Math.ceil(length / 30) + 3);
  };

  /*
  *Function for parsing date
  *@param date - date when invitation was sent
  */
  Form.prototype.dateParse = function(date){
    var today = new Date();
    return (Math.floor((today-date)/(1000*60*60*24)));
  };

  /*
  *Function change visibility of two elements
  */
  Form.prototype.changeVisibility = function(show){
    $('.popUp').hide('fast');
    $('#' + show).show('fast');
  };

  /*
  *Function for handover data from html element
  */
  Form.prototype.elementHandover = function(element, data){
    this.formArray[element] = data;
    if(element === 'sendTest' && !data){
      $('#selectTemplate').hide('fast');
    }
    if(element === 'sendTest' && data){
      $('#selectTemplate').show('fast');
    }
  };

  /*
  *Function for setting date to candidate
  */
  Form.prototype.chandeDateToHTML = function(element, data, status){
    var obj = this;
    this.choosenElement.find('#' + element).html('');
    obj.choosenElement.find('#' + element).replaceWith(data);
    this.changeStatus(status);
    obj.datePrescreeningChange = false;
    obj.dateInterviewChange = false;
  };

  /*
  *Function for setting date to candidate structure
  */
  Form.prototype.dateHandover = function(element, data){
    var obj = this;
    if(element === 'prescreening'){
      if(data){
        obj.choosenCandidate.dateOfPrescreening = new Date(data);
        obj.choosenCandidate.status = obj.findStatus(6);
        data = obj.datePrescreening(obj.choosenCandidate);
        obj.chandeDateToHTML(element, data, 6);
      }
    }
    if(element === 'interview'){
      if(data){
        obj.choosenCandidate.dateOfInterview = new Date(data);
        obj.choosenCandidate.status = obj.findStatus(7);
        data = obj.dateInterview(obj.choosenCandidate);
        obj.chandeDateToHTML(element, data, 7);
        obj.choosenElement.find('#prescreening').removeClass('expired');
      }
    }
  };

  /*
  *Function for prepare invite emails
  */
  Form.prototype.prepareInvitation = function(){
    $('.invitation').html('');
    $('.filter').html('');
  };

  /*
  *Function for hiding elementy after set time
  *@param element - which element will disappear, howLong - how long will element stay until it disappear
  */
  Form.prototype.setTimer = function(element, howLong){
    setTimeout(function(){
      $('.' + element).remove().empty();
    }, howLong);
  };

  /*
  *Function for canceling invitation
  *@param element - pointer on html object
  */
  Form.prototype.cancelInvitation = function(element){
    var idOfTest;
    var obj = this;
    element = element.find('#nameOfTest');
    obj.testArray.some(function(test){
        if(element.text() === test.name_of_test){
        idOfTest = test.id;
        return true;
      }
    });
    window.open('https://www.hackerrank.com/x/tests/all/' + idOfTest + '/candidates/invited', '_blank');
  };

  /*
  *Function for showing all tests
  */
  Form.prototype.loadTestToSelect = function(){
    $('.testRemove').html('');
    $('.testRemove').append('<option value = "0" selected>Vyberte test</option>');
    this.testArray.some(function(test){
      $('.testRemove').append('<option value = "' + test.id + '">' + test.name_of_test + '</option>');
    });
  };


  /*
  *Function for parsing email text for macros
  *@param text - text of email
  */
  Form.prototype.parseEmail = function(link, text, password){
    var date = new Date();
    //editing URL due to zimbra cannot shows data after ? over URL mailto
    var linkTest = link;
    if(link !== 'Nezadano'){
      linkTest = linkTest.replace(/\?/g, '%3F');
    }

    function isOdd(num) { return num % 2;}

    var days = date.getDate() + 7;
    var months = date.getMonth() + 1;
    var years = date.getFullYear();

    if(months === 2){
      days -= 28;
      months += 1;
    }else if(isOdd(months)){
      if(days > 31){
        days -= 31;
        months += 1;
      }
    }else{
      if(days > 30){
        days -= 30;
        months += 1;
      }
    }
    if(months > 12){
      months -= 12;
      years += 1;
    }
    date = days + '. ' + months + '. ' + years + ' v ' +
      date.getHours() + ':' + date.getMinutes();
    //replace of name
    var name = '';
    if(this.formArray.name){
      name = this.formArray.name;
    }
    text = text.replace(/\{NAME\}/g, name); //g is here for global matching
    text = text.replace(/\{DATE\}/g, date);  //replace of date
    text = text.replace(/\{LINK\}/g, linkTest);  //replace of link
    text = text.replace(/\{EOL\}/g, '%0D%0A');  //replace of new line
    if(password){
      text = text.replace(/\{PASSWORD\}/g, 'Heslo k testu: ' + password);  //replace of password
    }else{
      text = text.replace(/\{PASSWORD\}/g, '');  //replace of password
    }
    return text;
  };

  /*
  *Function, which will find email template from id
  */
  Form.prototype.findTemplate = function(id){
    var obj = this;
    var emailTemplate = {};
    $.each(obj.emailTemplates, function(i, template){
      if(template.id === id){
        emailTemplate = template;
      }
    });
    return emailTemplate;
  };

  /*
  *Function for parse invitation data
  *@param data - json data
  */
  Form.prototype.parseInvitation = function(content){
    var obj = this;
    var emailTemplate = obj.findTemplate(obj.formArray.emailTemplate);
    var emailText = '';
    if(content && content.data.password){
      var password = content.data.password;
      emailText = obj.parseEmail(content.data.test_link, emailTemplate.text, password);
    }else{
      emailText = obj.parseEmail(content.data.test_link, emailTemplate.text, '');
    }
    obj.choosenCandidate.testLink = content.data.test_link;
    var email = obj.choosenCandidate.email;
    obj.sendEmail(emailText, email, emailTemplate.subject);
    obj.formArray.emailTemplate = 1;
    $('#emailTemplate').val(1);
  };

  /*
  *Function for opening new email in email browser
  */
  Form.prototype.sendEmail = function(emailText, email, subject){
    var mailtoLink = 'mailto:' + email + '?subject=' + subject + '&body=' + emailText;
    window.open(mailtoLink, '_blank');
  };

  /*
  *Function for creating test
  */
  Form.prototype.createTest = function(){
    var obj = this;
    obj.choosenCandidate = {};
    obj.formArray.email = $('#email').val();
    obj.formArray.inviteTest = $('#invitationTestId').val();
    obj.formArray.name = $('#nameOfUser').val();
    obj.formArray.sendTest = $('#sendTest').prop('checked');
    if(obj.formArray.email.length === 0 || obj.formArray.inviteTest === '0'){
      obj.showError('Špatně vyplněno', '', '');
    }else{
      var duplicate = 0;
      obj.personArray.some(function(person){ //check if user is not invited on the same test twice
        if(obj.formArray.inviteTest === person.testID &&
          obj.formArray.email === person.email){
          obj.choosenCandidate = person;
          if(!(person.status && person.status.id === -1)){
            duplicate = 1;
          }
          return true;
        }
      });

      if(duplicate === 0){
        var note1 = $('#inviteNote1').val();
        var note2 = $('#inviteNote2').val();
        var dat = {
          'name' : obj.formArray.name,
          'id_test': obj.formArray.inviteTest,
          'username': obj.formArray.email,
          'note1': note1,
          'note2': note2,
          'send_email': 'false',
          'force': 'true',
          'hide_login_credentials': 'true',
          'send_test': obj.formArray.sendTest,
          'email_template': obj.formArray.emailTemplate
        };
        $.ajax({
          method: 'POST',
          url: '/send_invite',
          data: JSON.stringify(dat),
          success: function(content){
            content = JSON.parse(content);
            if(obj.formArray.sendTest){
              if(obj.choosenCandidate && obj.choosenCandidate.status && obj.choosenCandidate.status.id === -1){
                obj.showSuccess('Test vytvořen');
                obj.choosenCandidate.testLink = content.data.test_link;
                obj.choosenCandidate.status = obj.findStatus(0);
                obj.choosenCandidate.passwordToTest = content.data.password;
                obj.saveInformations();
              }else{
                obj.createUser(note1, note2, content);
              }
              obj.parseInvitation(content);
            }else{
              obj.showSuccess('Uživatel přidán');
              obj.createUser(note1, note2, '');
            }
          }
        }).fail(function(jqXHR, textStatus, errorThrown){
          obj.showError('Chyba při odesílání pozvánky: ', textStatus, errorThrown);
        });

      }else{
        obj.showError('Uživatel je již pozvaný na stejný test, test nebyl vytvořen.', '', '');
      }
    }
    $('#nameOfUser').val('');
    $('#email').val('');
    $('#invitationTestId').val(0);
    $('#inviteNote1').val('');
    $('#inviteNote2').val('');
  };

  /*
  *Function for creating user
  */
  Form.prototype.createUser = function(note1, note2, testInformations){
    var obj = this;
    var password = '';
    var linkToTest = '';
    if(testInformations){
      password = testInformations.data.password;
      linkToTest = testInformations.data.test_link;
    }
    var name = '';
    var invites = [{date_send: new Date()}];
    var status = obj.findStatus(0);
    if(!obj.formArray.sendTest){
      status = obj.findStatus(-1);
    }
    name = obj.formArray.name;
    if(!name){
      name = '';
    }
    var nameTest = obj.findTestName(obj.formArray.inviteTest);
    var candidate = {
        databaseID: null,
        testLink: linkToTest, //link for test
        userId: null, //id of user
        nameOfTest: nameTest, //name of test
        testID: obj.formArray.inviteTest, //test id
        endTimeTestW: 1, // date when test was written
        dateOfInvite: new Date(), //when was user invited
        howManyTimesW: 1, // how many different test user writes
        ats: 0,
        status: status,
        userStatus: -1, // user status
        email: obj.formArray.email, //email of user
        nameOfUser: name,//name of user
        report: null, // link of user report
        dayLeftFromInvitation: obj.dateParse(new Date()), //how many days from invite left
        dayLeftFromTestW: null,// how many days from test written left
        comment: null, //comment with results of test
        dateOfInterview: '',
        dateOfPrescreening: '',
        note1: note1 ? note1 : '',
        note2: note2 ? note2 : '',
        invites: invites,
        passwordToTest: password
      };
    obj.choosenCandidate = candidate;
    obj.personArray.push(candidate);
    var candidateHtml = obj.convertToHtml(candidate);
    $('#testUsers').append(candidateHtml);
    obj.formArray.inviteTest = 0;
  };

  /*
  * Function for checking, if there is any column active
  */
  Form.prototype.isSomethingActive = function(){
    if(this.nameChange || this.statusChange || this.dateInterviewChange || this.note1Change || this.note2Change || this.datePrescreeningChange){
         return true;
    }
    return false;
  };

  /*
  * Function for buttons events
  */
  Form.prototype.buttonClicks = function(){
    var obj = this;
    var password = '';
    var passwordStruct ={oldPass: '', newPass: '', newPassAgain: ''};

    $(document).click(function(e) {
      var target = e.target;
      var data = '';
      if (!$(target).is('#interview') &&
          !$(target).is('#dateOfInterview') &&
          !$(target).is('#cancelInterview') &&
          obj.dateInterviewChange && obj.isSomethingActive()) {
        obj.choosenElement.find('#interview').html('');
        if(obj.choosenCandidate.dateOfInterview){
          data = obj.dateInterview(obj.choosenCandidate);
          obj.choosenElement.find('#interview').replaceWith(data);
          obj.choosenElement.find('#prescreening').removeClass('expired');
        }else{
          obj.choosenElement.find('#interview').html(data);
          obj.choosenElement.find('#interview').removeClass('expired');
        }
        obj.dateInterviewChange = false;
        return false;
      }
      if (!$(target).is('#note1') && !$(target).is('#n1') && obj.note1Change) {
        obj.choosenCandidate.note1 = obj.choosenElementNote1.find('#n1').val();
        obj.choosenElementNote1.find('#note1').html('');
        obj.choosenElementNote1.find('#note1').append(obj.choosenCandidate.note1);
        obj.note1Change = false;
        obj.saveInformations();
        return false;
      }
      if (!$(target).is('#note2') && !$(target).is('#n2') && obj.note2Change) {
        obj.choosenCandidate.note2 = obj.choosenElementNote2.find('#n2').val();
        obj.choosenElementNote2.find('#note2').html('');
        obj.choosenElementNote2.find('#note2').append(obj.choosenCandidate.note2);
        obj.note2Change = false;
        obj.saveInformations();
        return false;
      }
      if (!$(target).is('#prescreening') &&
          !$(target).is('#dateOfPrescreening') &&
          !$(target).is('#cancelPrescreening') &&
          obj.datePrescreeningChange) {
        obj.choosenElement.find('#prescreening').html('');
        if(obj.choosenCandidate.dateOfPrescreening){
          data = obj.datePrescreening(obj.choosenCandidate);
          obj.choosenElement.find('#prescreening').replaceWith(data);
        }else{
          data = '';
          obj.choosenElement.find('#prescreening').html(data);
        }
        obj.datePrescreeningChange = false;
        return false;
      }
      if (!$(target).is('#status') && !$(target).is('#selectStatus') && obj.statusChange) {
        obj.choosenElement.find('#status').html('');
        obj.choosenElement.find('#status').html(obj.choosenCandidate.status.name_status);
        obj.statusChange = false;
        return false;
      }
      if (!$(target).is('#nameAndEmail') && !$(target).is('#nameChange') && obj.nameChange) {
        obj.choosenCandidate.nameOfUser = $('#nameChange').val();
        obj.saveInformations();
        obj.choosenElement.find('#nameAndEmail').html('');
        obj.choosenElement.find('#nameAndEmail').html(obj.choosenCandidate.nameOfUser +
          '<div id="emailOfUser">' + obj.choosenCandidate.email + '</div>');
        obj.nameChange = false;
        return false;
      }
    });

    $('#openInvitation').click(function(){
      obj.loadTestToSelect();
      obj.choosenCandidate = {};
      if(obj.invitationVisible){
        $('#invitation').hide('fast');
        obj.invitationVisible = false;
        obj.filteringVisible = false;
      }else{
        obj.changeVisibility('invitation');
        obj.invitationVisible = true;
        obj.filteringVisible = false;
      }
      obj.prepareInvitation();
    });

    $('#filter').click(function(){
      if(!$('#filter').hasClass('disabled')){
        if(obj.filteringVisible){
          $('#filtering').hide('fast');
          obj.filteringVisible = false;
          obj.invitationVisible = false;
        }else{
          obj.changeVisibility('filtering');
          obj.filteringVisible = true;
          obj.invitationVisible = false;
        }
      }
    });

    $('#sendInvitation').click(function(){
      if(confirm('Opravdu chcete přidat tohoto uchazeče?')){
        obj.createTest();
      }
    });

    $('body').on('click', '#cancelInvitation', function(){
      obj.cancelInvitation(obj.choosenElement);
    });

    $('#timeout').on('click', '#continue', function(){
      $('.timeout').remove();
      obj.timeoutForData();
    });

    $('#refreshButton').click(function(){
      $('.popUp').hide('fast');
      obj.filteringVisible = false;
      obj.invitationVisible = false;
      obj.refresh = true;
      obj.inicializeFunction();
    });

    $('body').on('click', '#informations', function(){
      obj.htmlElement = $(this).closest('tr');
      obj.findNearbyEmail(obj.htmlElement);
      $('#dateofPrescreening').val(obj.choosenCandidate.dateOfPrescreening);
      $('#dateOfInterview').val(obj.choosenCandidate.dateOfInterview);
      $('#dates').html('');
      var templateName = '';
      $.each(obj.choosenCandidate.invites, function(i, invite){
        $.each(obj.emailTemplates, function(i, template){
          if(template.id === invite.email_id){
            templateName = template.name_of_template;
          }
        });
        var dateBefore = new Date(invite.date_send);
        var date = obj.convertToNormDate(invite.date_send);
        $('#dates').append(date + ' (před ' + obj.dateParse(dateBefore) + ' dny) - ' + templateName + '<br>');
      });
    });

    $('body').on('click', '#refreshDatabaseWithoutComments', function(){
      obj.refreshDatabase(false);
    });

    $('body').on('click', '#refreshDatabaseWithComments', function(){
      if(confirm('Opravdu chcete udělat kompletní update databáze? Tato akce může trvat až několik minut.')){
        obj.refreshDatabase(true);
      }
    });

    $('body').on('click', '#status', function(event){
      event.stopPropagation();
      if(!obj.isSomethingActive()){
        obj.choosenElement = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElement);
        obj.choosenElement.find('#status').html('');
        var select = '<select id="selectStatus" class="selectBox" onchange="mainForm.changeStatus(this.value);">' +
                     '<option value = "-1" disabled selected>Vyberte status</option>';
        $.each(obj.statuses, function(i, status){
          select += '<option value = "' + status.id + '">' + status.name_status + '</option>';
        });
        select += '</select>';
        obj.choosenElement.find('#status').append(select);
        obj.statusChange = true;
        return false;
      }
    });
    $('body').on('click', '#testinformations', function(){
      obj.choosenElement = $(this).closest('tr');
      obj.findNearbyEmail(obj.choosenElement);
      obj.loadTestToSelect();
      if(obj.choosenCandidate.status.id === 0 || obj.choosenCandidate.status.id === 4){ //invited, test not wrote
        obj.removeTestFromSelect(obj.choosenCandidate.nameOfTest);
        $('#invitedNotWritten').modal('show');
      }else if(obj.choosenCandidate.status.id === -1){ //new without test
        obj.removeTestFromSelect(obj.choosenCandidate.nameOfTest);
        $('#inviteForNewTest').modal('show');
      }else if(obj.choosenCandidate.status.id === 1){ //not corrected
        obj.removeTestFromSelect(obj.choosenCandidate.nameOfTest);
        $('#writtenNotCorrected').modal('show');
      }else{
        obj.removeTestFromSelect(obj.choosenCandidate.nameOfTest);
        $('#inviteForAnotherTest').modal('show');
      }
    });

    $('body').on('click', '#inviteOnTest', function(){
      obj.loadTestToSelect();
      obj.invitationVisible = true;
      obj.changeVisibility('invitation');
      obj.prepareInvitation();
      obj.formArray.email = obj.choosenCandidate.email;
      obj.formArray.name = obj.choosenCandidate.name;
      obj.formArray.emailTemplate = 1;
      $('#nameOfUser').val(obj.choosenCandidate.nameOfUser);
      $('#email').val(obj.choosenCandidate.email);
      $('#inviteNote1').val(obj.choosenCandidate.note1);
      $('#inviteNote2').val(obj.choosenCandidate.note2);
      //we dont want to send invitation on the same test, so we hide the test on which was user invited
      if(!(obj.choosenCandidate && obj.choosenCandidate.status && obj.choosenCandidate.status.id === -1)){
        obj.testArray.some(function(test){
          if(obj.choosenCandidate.testID === test.id){
            $('.testRemove option[value = "' + test.id + '"]').hide('fast');
            return true;
          }
        });
      }
    });

    $('body').on('click', '#openTest', function(){
      if(obj.choosenCandidate.report){
        window.open(obj.choosenCandidate.report, '_blank');
      }else{
        alert('Kandidát nemá napsaný test');
      }
    });

    $('body').on('click', '#remindCandidate', function(){
      obj.submitRemind();
    });

    $('body').on('click', '#prescreening', function(event){
      if(!obj.isSomethingActive()){
        event.stopPropagation();
        obj.choosenElement = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElement);
        obj.choosenElement.find('#prescreening').html('');
        var date = obj.convertToSysDate(obj.choosenCandidate.dateOfPrescreening);
        var fun = 'mainForm.dateHandover("prescreening", this.value);';
        var dateInput = '<input type="date" id="dateOfPrescreening" value="' + date + '" onchange="' + fun + '"/><br>' +
                        '<input type="button" id="cancelPrescreening" value="Zrušit termín"/>';
        obj.choosenElement.find('#prescreening').append(dateInput);
        obj.datePrescreeningChange = true;
      }
    });

    $('body').on('click', '#interview', function(event){
      if(!obj.isSomethingActive()){
        event.stopPropagation();
        obj.choosenElement = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElement);
        obj.choosenElement.find('#interview').html('');
        var date = obj.convertToSysDate(obj.choosenCandidate.dateOfInterview);
        var fun = 'mainForm.dateHandover("interview", this.value);';
        var dateInput = '<input type="date" id="dateOfInterview" value="' + date + '" onchange="' + fun + '"/><br>' +
                        '<input type="button" id="cancelInterview" value="Zrušit termín"/>';
        obj.choosenElement.find('#interview').append(dateInput);
        obj.dateInterviewChange = true;
        return false;
      }
    });

    $('body').on('click', '#cancelPrescreening', function(event){
      event.preventDefault();
      event.stopPropagation();
      obj.choosenElement = $(this).closest('tr');
      obj.findNearbyEmail(obj.choosenElement);
      obj.choosenCandidate.dateOfPrescreening = null;
      obj.choosenElement.find('#prescreening').html('');
      obj.choosenElement.find('#prescreening').removeClass('expired');
      obj.datePrescreeningChange = false;
      obj.saveInformations();
      return false;
    });

    $('body').on('click', '#cancelInterview', function(event){
      event.preventDefault();
      event.stopPropagation();
      obj.choosenElement = $(this).closest('tr');
      obj.findNearbyEmail(obj.choosenElement);
      obj.choosenCandidate.dateOfInterview = null;
      obj.choosenElement.find('#interview').html('');
      obj.choosenElement.find('#interview').removeClass('expired');
      if(obj.dateParse(new Date(obj.choosenCandidate.dateOfPrescreening)) > obj.lengthOfExpiration){
        obj.choosenElement.find('#prescreening').addClass('expired');
      }
      obj.dateInterviewChange = false;
      obj.saveInformations();
    });

    $('input[type=password]').on('keyup', function () {
     password = $(this).val();
    });

    $('#oldpassword').on('keyup', function () {
     passwordStruct.oldPass = $(this).val();
    });

    $('#newPassword').on('keyup', function () {
     passwordStruct.newPass = $(this).val();
    });

    $('#newPasswordAgain').on('keyup', function () {
     passwordStruct.newPassAgain = $(this).val();
    });

    $('body').on('click', '#changePassword', function(){
      passwordStruct = {};
    });

    $( '#emailTemplateChange' ).change(function() {
      var idTemplate = $(this).val();
      obj.choosenTemplate = obj.findTemplate(idTemplate);
      $('#nameOfTemplate').val(obj.choosenTemplate.name_of_template);
      $('#subjectOfEmail').val(obj.choosenTemplate.subject);
      $('#templateText').val(obj.choosenTemplate.text);
    });

    $('body').on('click', '#changePasswordButton', function(){
      obj.changePassword(passwordStruct);
    });

    $('body').on('click', '#saveNewUser', function(){
      var name = $('#nameOfNewUser').val();
      var auth = $('#authorization').val();
      if(name !== '' && password !== ''){
        obj.saveNewUser(name, password, auth);
      }
    });

    $('body').on('click', '#addEmailTemplate', function(){
      obj.choosenTemplate = {};
      obj.setTemplateInputEmpty();
    });

    $('body').on('click', '#note1', function(event){
      if(!obj.isSomethingActive()){
        event.stopPropagation();
        obj.note1Change = true;
        obj.choosenElementNote1 = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElementNote1);
        obj.choosenElementNote1.find('#note1').html('');
        var rows = obj.textAreaAdjust(obj.choosenCandidate.note1);
        var area = '<textarea id="n1" rows="' + rows + '" cols="30" onkeyup="mainForm.auto_grow(this)">' + obj.choosenCandidate.note1 + '</textarea>';
        obj.choosenElementNote1.find('#note1').append(area);
      }
    });

    $('body').on('click', '#nameAndEmail', function(event){
      if(!obj.isSomethingActive()){
        event.stopPropagation();
        obj.nameChange = true;
        obj.choosenElement = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElement);
        obj.choosenElement.find('#nameAndEmail').html('');
        var area = '<input id="nameChange" value="' + obj.choosenCandidate.nameOfUser + '"/>';
        obj.choosenElement.find('#nameAndEmail').append(area);
        return false;
      }
    });

    $('body').on('click', '#note2', function(event){
      if(!obj.isSomethingActive()){
        event.stopPropagation();
        obj.note2Change = true;
        obj.choosenElementNote2 = $(this).closest('tr');
        obj.findNearbyEmail(obj.choosenElementNote2);
        obj.choosenElementNote2.find('#note2').html('');
        var rows = obj.textAreaAdjust(obj.choosenCandidate.note2);
        var area = '<textarea id="n2" rows="' + rows + '" cols="60" onkeyup="mainForm.auto_grow(this)">' + obj.choosenCandidate.note2 + '</textarea>';
        obj.choosenElementNote2.find('#note2').append(area);
      }
    });

    $('body').on('click', '#saveEmailTemplate', function(){
      var name = $('#nameOfTemplate').val();
      var subject = $('#subjectOfEmail').val();
      var text = $('#templateText').val();
      obj.choosenTemplate.text = text;
      obj.choosenTemplate.subject = subject;
      obj.choosenTemplate.name_of_template = name;
      if(this.choosenTemplate){
        $('#emailTemplateChange option:selected').text(obj.choosenTemplate.name_of_template);
      }
      if(name && subject && text){
        obj.saveNewTemplate(name, subject, text);
      }
    });

    $('body').on('click', '#deleteTemplate', function(){
      if(confirm('Opravdu chcete smazat emailovou šablonu?')){
        obj.deleteTemplate();
      }
    });

    $('body').on('click', '#changeExpiration', function(){
      var value = $('#expiration').val();
      if(value){
        obj.lengthOfExpiration = value;
        obj.setExpirationDate(value);
      }
    });
  };

  Form.prototype.auto_grow = function(element) {
      element.style.height = '5px';
      element.style.height = (element.scrollHeight)+'px';
  };

  Form.prototype.changePassword = function(passwords){
    var obj = this;
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(passwords),
      url: '/change_password',
      success: function(content){
        if(content === 'false'){
          obj.showError('Hesla se neshodují', '', '');
        }else{
          obj.showSuccess('Heslo změněno');
        }
      }
    });
  };

  /*
  * Function for setting expiration
  */
  Form.prototype.setExpirationDate = function(value){
    var obj = this;
    var data = {'value': value};
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(data),
      url: '/set_expiration',
      success: function(content){
        if(content === 'true'){
          $('expiration').val(obj.lengthOfExpiration);
          obj.refresh = true;
          obj.inicializeFunction();
        }
      }
    });
  };

  /*
  * Function for clear inputs
  */
  Form.prototype.setTemplateInputEmpty = function(){
    $('#nameOfTemplate').val('');
    $('#templateText').val('');
    $('#subjectOfEmail').val('');
    $('#emailTemplateChange').val(-1);
  };

  /*
  * Function for deleting email template
  */
  Form.prototype.deleteTemplate = function(){
    var id = -1;
    if(this.choosenTemplate.id){
      id = this.choosenTemplate.id;
    }
    if(id < -1 || id > 2){
      var obj = this;
      $('#emailTemplateChange option:selected').remove();
      $('#emailTemplate option[value="' + this.choosenTemplate.id + '"]').remove();
      var template = {id: id};
      $.ajax({
        method: 'POST',
        dataType: 'json',
        data: JSON.stringify(template),
        url: '/delete_template',
        success: function(content){
          if(content === 'false'){
            obj.showError('Chyba při mazání šablony', '', '');
          }else{
            obj.showSuccess('Šablona smazána');
          }
        }
      });
    }else{
      alert('Tuto šablonu nelze odstranit. Lze ji pouze upravit.');
    }
    this.setTemplateInputEmpty();

    this.choosenTemplate = {};
  };

  /*
  * Function for creating new email template
  */
  Form.prototype.saveNewTemplate = function(name, subject, text){
    var id = -1;
    if(this.choosenTemplate.id){
      id = this.choosenTemplate.id;
    }
    var template = {id: id, name_of_template: name, subject: subject, text: text};
    var obj = this;
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(template),
      url: '/save_email_template',
      success: function(content){
        obj.showSuccess('Šablona uložena');
        if(content.id){
          template.id = content.id;
          obj.emailTemplates.push(template);
          $('.emailTemplate').append('<option value = "' + template.id + '">' + template.name_of_template + '</option>');
          obj.choosenTemplate = {};
        }
      }
    });
  };

  /*
  * Function for creating new user
  */
  Form.prototype.saveNewUser = function(name, password, auth){
    var user = {name: name, password: password, auth: auth};
    var obj = this;
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(user),
      url: '/save_user',
      success: function(){
        obj.showSuccess('Uživatel vytvořen');
      }
    });
  };

  /*
  * Function for removing test from selects
  */
  Form.prototype.removeTestFromSelect = function(nameOfTest){
    var obj = this;
    obj.testArray.some(function(test){
      if(nameOfTest === test.name_of_test){
        $('.testRemove option[value = "' + test.id + '"]').hide('fast');
        return true;
      }
    });
  };

  /*
  * Function for submitting remind
  */
  Form.prototype.submitRemind = function(){
    var obj = this;
    var password = '';
    if(obj.choosenCandidate && obj.choosenCandidate.passwordToTest){
      password = obj.choosenCandidate.passwordToTest;
    }
    var data = '{"data":{"test_link": "' + obj.choosenCandidate.testLink + '", "password": "' + password + '"}}';
    obj.formArray.email = obj.choosenCandidate.email;
    obj.formArray.emailTemplate = '2';
    obj.formArray.name = obj.choosenCandidate.nameOfUser;
    obj.parseInvitation(JSON.parse(data));
    obj.saveInvToDatabase(obj.choosenCandidate, 2);
    obj.choosenCandidate.howManyTimesW += 1;
    obj.choosenCandidate.invites.push({date_send: new Date()});
    var text = (obj.choosenCandidate.howManyTimesW - 1) + ' upomenutí.</div> Naposledy před: <div id="whenLastInvited">' +
    this.lastInvite(obj.choosenCandidate)+'</div>';
    obj.changeInHTML(obj.choosenElement, 'remindCount', text);
  };

  /*
  * Function for changing status
  */
  Form.prototype.changeStatus = function(data){
    var obj = this;
    obj.choosenElement.removeClass(obj.choosenCandidate.status.tag);
    obj.choosenElement.find('#status').html('');
    obj.choosenCandidate.status = obj.findStatus(data);
    obj.choosenElement.addClass(obj.choosenCandidate.status.tag);
    obj.choosenElement.find('#status').html(obj.choosenCandidate.status.name_status);

    if (data !== 1) {//not corrected
        obj.choosenElement.find('#testinformations').removeClass('notCorrectedForLong');
    } else {
        obj.choosenElement.find('#testinformations').addClass(this.checkMarkDelay(obj.choosenCandidate));
    }

    if(data > 9){
      obj.choosenElement.find('#interview').removeClass('expired');
    }else{
      if(obj.choosenCandidate.dateOfInterview){
        if(obj.dateParse(new Date(obj.choosenCandidate.dateOfPrescreening)) > obj.lengthOfExpiration){
          obj.choosenElement.find('#interview').addClass('expired');
        }
      }
    }
    obj.saveInformations();
    obj.statusChange = false;
  };

  /*
  * Function for finding email from row
  */
  Form.prototype.findNearbyEmail = function(element){
    if(element){
      var email = element.find('#emailOfUser').text();
      var nameOfTest = element.find('#nameOfTest').text();
      this.choosenCandidate = this.findCandidate(nameOfTest, email);
    }
  };

  /*
  * Function for changing datas in html
  */
  Form.prototype.changeInHTML = function(element, id, value){
    element.find('#' + id).html(value);
  };

  /*
  * Function for saving invitations in database
  */
  Form.prototype.saveInvToDatabase = function(user){
    var invitationInfo = {'id_test': user.testID ,'email': user.email, 'date': new Date(), 'id_email_template': 1};
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(invitationInfo),
      url: '/insert_invite',
      success: function(){
        console.log('success');
      }
    });
  };

  /*
  * Function for sync database
  */
  Form.prototype.refreshDatabase = function(withComments){
    this.showWarning('Probíhá aktualizace databáze');
    var loadComments = {'loadComments' : withComments};
    $.ajax({
      method: 'POST',
      dataType: 'json',
      data: JSON.stringify(loadComments),
      url: '/load_contents',
      success: function(){
        $('.alert-success').remove('fast');
      }
    });
  };

  /*
  * Function for updating informations about candidates
  */
  Form.prototype.saveInformations = function(){
    var note_data = {'id_test' : this.choosenCandidate.testID,
                 'username' : this.choosenCandidate.email,
                 'note1': this.choosenCandidate.note1,
                 'note2': this.choosenCandidate.note2,
                 'name': this.choosenCandidate.nameOfUser,
                 'date_of_prescreening': this.choosenCandidate.dateOfPrescreening,
                 'date_of_interview': this.choosenCandidate.dateOfInterview,
                 'status': this.choosenCandidate.status.id};
    var obj = this;
    $.ajax({
      method: 'POST',
      url: '/save_informations',
      data: JSON.stringify(note_data),
      success: function(){
        console.log('Saved');
      }
    }).fail(function(jqXHR, textStatus, errorThrown){
      obj.showError('Chyba při ukládání poznámky ', textStatus, errorThrown);
    });

  };

  /*
  * Function for finding candidate
  */
  Form.prototype.findCandidate = function(nameOfTest, email){
    var obj = this;
    var user = {};
    $.each(obj.personArray, function(i, candidate){
      if(candidate.email === email && candidate.nameOfTest === nameOfTest){
        user = candidate;
      }
    });
    return user;
  };

  /*
  *Function for showing how long was not site reloaded
  */
  Form.prototype.howLongLoaded = function(){
    clearInterval(this.timer);
    var date = new Date();

    this.timer = setInterval( function(){
      var difference = (new Date() - date)/1000;
      $('#second').html(parseInt(difference % 60));
      $('#minutes').html(parseInt(difference / 60));
    }, 5000);
  };

  /*
  *Function for hiding elements at when page loads
  */
  Form.prototype.hideElements = function(){
    $('#filtering').hide('fast');
    $('#invitation').hide('fast');
    $('#headerTable').hide('fast');
  };

  $(document).ready(function(){
    var x=0;
    setInterval(function() {
      var dots = '';
      x++;
      for (var y=0; y < x%4; y++) {
          dots += '.';
      }
      $('#loading-dots').text(dots);
    } , 300);

    $(window).bind('scroll', function () {
      if ($(window).scrollTop() > 350) {
        $('#headerTable').show('fast');
      } else {
        $('#headerTable').hide('fast');
      }
    });
    mainForm = new Form();
    mainForm.buttonClicks();
  });
}());
